Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 75772)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -3127,222 +3098,298 @@
              * translation. If we instead return the reparse tag in Information, and store
              * a pointer to the reparse data buffer in Irp->Tail.Overlay.AuxiliaryBuffer,
              * IopSymlinkProcessReparse will do the translation for us. */
-            
+
             Status = get_reparse_block(fileref->fcb, (UINT8**)&data);
             if (!NT_SUCCESS(Status)) {
                 ERR("get_reparse_block returned %08x\n", Status);
-                free_fileref(fileref);
+                Status = STATUS_SUCCESS;
+            } else {
+                Status = STATUS_REPARSE;
+                Irp->IoStatus.Information = data->ReparseTag;
+
+                if (fn.Buffer[(fn.Length / sizeof(WCHAR)) - 1] == '\\')
+                    data->Reserved = sizeof(WCHAR);
+
+                Irp->Tail.Overlay.AuxiliaryBuffer = (void*)data;
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
-            
-            Status = STATUS_REPARSE;
-            Irp->IoStatus.Information = data->ReparseTag;
-            
-            if (fn.Buffer[(fn.Length / sizeof(WCHAR)) - 1] == '\\')
-                data->Reserved = sizeof(WCHAR);
-            
-            Irp->Tail.Overlay.AuxiliaryBuffer = (void*)data;
-            
-            free_fileref(fileref);
-            goto exit;
         }
-        
+
         if (fileref->fcb->type == BTRFS_TYPE_DIRECTORY && !fileref->fcb->ads) {
             if (options & FILE_NON_DIRECTORY_FILE && !(fileref->fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT)) {
-                free_fileref(fileref);
                 Status = STATUS_FILE_IS_A_DIRECTORY;
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
         } else if (options & FILE_DIRECTORY_FILE) {
             TRACE("returning STATUS_NOT_A_DIRECTORY (type = %u, %S)\n", fileref->fcb->type, file_desc_fileref(fileref));
-            free_fileref(fileref);
             Status = STATUS_NOT_A_DIRECTORY;
+
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+
             goto exit;
         }
-        
+
         if (fileref->open_count > 0) {
-            Status = IoCheckShareAccess(granted_access, Stack->Parameters.Create.ShareAccess, FileObject, &fileref->fcb->share_access, TRUE);
-            
+            Status = IoCheckShareAccess(granted_access, IrpSp->Parameters.Create.ShareAccess, FileObject, &fileref->fcb->share_access, FALSE);
+
             if (!NT_SUCCESS(Status)) {
-                WARN("IoCheckShareAccess failed, returning %08x\n", Status);
-                
-                free_fileref(fileref);
+                if (Status == STATUS_SHARING_VIOLATION)
+                    TRACE("IoCheckShareAccess failed, returning %08x\n", Status);
+                else
+                    WARN("IoCheckShareAccess failed, returning %08x\n", Status);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
-        } else {
-            IoSetShareAccess(granted_access, Stack->Parameters.Create.ShareAccess, FileObject, &fileref->fcb->share_access);
-        }
 
+            IoUpdateShareAccess(FileObject, &fileref->fcb->share_access);
+        } else
+            IoSetShareAccess(granted_access, IrpSp->Parameters.Create.ShareAccess, FileObject, &fileref->fcb->share_access);
+
         if (granted_access & FILE_WRITE_DATA || options & FILE_DELETE_ON_CLOSE) {
             if (!MmFlushImageSection(&fileref->fcb->nonpaged->segment_object, MmFlushForWrite)) {
                 Status = (options & FILE_DELETE_ON_CLOSE) ? STATUS_CANNOT_DELETE : STATUS_SHARING_VIOLATION;
-                
-                free_fileref(fileref);
+
+                IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
         }
-        
+
         if (RequestedDisposition == FILE_OVERWRITE || RequestedDisposition == FILE_OVERWRITE_IF || RequestedDisposition == FILE_SUPERSEDE) {
             ULONG defda, oldatts, filter;
             LARGE_INTEGER time;
             BTRFS_TIME now;
-            
-            if ((RequestedDisposition == FILE_OVERWRITE || RequestedDisposition == FILE_OVERWRITE_IF) && fileref->fcb->atts & FILE_ATTRIBUTE_READONLY) {
+
+            if ((RequestedDisposition == FILE_OVERWRITE || RequestedDisposition == FILE_OVERWRITE_IF) && readonly) {
                 WARN("cannot overwrite readonly file\n");
                 Status = STATUS_ACCESS_DENIED;
-                free_fileref(fileref);
+
+                IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+
                 goto exit;
             }
-    
-            // FIXME - where did we get this from?
-//             if (fcb->refcount > 1) {
-//                 WARN("cannot overwrite open file (fcb = %p, refcount = %u)\n", fcb, fcb->refcount);
-//                 Status = STATUS_ACCESS_DENIED;
-//                 free_fcb(fcb);
-//                 goto exit;
-//             }
-            
-            // FIXME - make sure not ADS!
-            Status = truncate_file(fileref->fcb, 0, Irp, rollback);
-            if (!NT_SUCCESS(Status)) {
-                ERR("truncate_file returned %08x\n", Status);
-                free_fileref(fileref);
-                goto exit;
+
+            if (fileref->fcb->ads) {
+                Status = stream_set_end_of_file_information(Vcb, 0, fileref->fcb, fileref, FALSE);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("stream_set_end_of_file_information returned %08x\n", Status);
+
+                    IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                    ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                    free_fileref(Vcb, fileref);
+                    ExReleaseResourceLite(&Vcb->fcb_lock);
+
+                    goto exit;
+                }
+            } else {
+                Status = truncate_file(fileref->fcb, 0, Irp, rollback);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("truncate_file returned %08x\n", Status);
+
+                    IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                    ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                    free_fileref(Vcb, fileref);
+                    ExReleaseResourceLite(&Vcb->fcb_lock);
+
+                    goto exit;
+                }
             }
-            
+
             if (Irp->Overlay.AllocationSize.QuadPart > 0) {
                 Status = extend_file(fileref->fcb, fileref, Irp->Overlay.AllocationSize.QuadPart, TRUE, NULL, rollback);
-                
+
                 if (!NT_SUCCESS(Status)) {
                     ERR("extend_file returned %08x\n", Status);
-                    free_fileref(fileref);
+
+                    IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                    ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                    free_fileref(Vcb, fileref);
+                    ExReleaseResourceLite(&Vcb->fcb_lock);
+
                     goto exit;
                 }
             }
-            
-            if (Irp->AssociatedIrp.SystemBuffer && Stack->Parameters.Create.EaLength > 0) {
-                ULONG offset;
-                FILE_FULL_EA_INFORMATION* eainfo;
-                
-                Status = IoCheckEaBufferValidity(Irp->AssociatedIrp.SystemBuffer, Stack->Parameters.Create.EaLength, &offset);
-                if (!NT_SUCCESS(Status)) {
-                    ERR("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
-                    free_fileref(fileref);
-                    goto exit;
+
+            if (!fileref->fcb->ads) {
+                if (Irp->AssociatedIrp.SystemBuffer && IrpSp->Parameters.Create.EaLength > 0) {
+                    ULONG offset;
+                    FILE_FULL_EA_INFORMATION* eainfo;
+
+                    Status = IoCheckEaBufferValidity(Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.Create.EaLength, &offset);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
+
+                        IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                        free_fileref(Vcb, fileref);
+                        ExReleaseResourceLite(&Vcb->fcb_lock);
+
+                        goto exit;
+                    }
+
+                    fileref->fcb->ealen = 4;
+
+                    // capitalize EA name
+                    eainfo = Irp->AssociatedIrp.SystemBuffer;
+                    do {
+                        STRING s;
+
+                        s.Length = s.MaximumLength = eainfo->EaNameLength;
+                        s.Buffer = eainfo->EaName;
+
+                        RtlUpperString(&s, &s);
+
+                        fileref->fcb->ealen += 5 + eainfo->EaNameLength + eainfo->EaValueLength;
+
+                        if (eainfo->NextEntryOffset == 0)
+                            break;
+
+                        eainfo = (FILE_FULL_EA_INFORMATION*)(((UINT8*)eainfo) + eainfo->NextEntryOffset);
+                    } while (TRUE);
+
+                    if (fileref->fcb->ea_xattr.Buffer)
+                        ExFreePool(fileref->fcb->ea_xattr.Buffer);
+
+                    fileref->fcb->ea_xattr.Buffer = ExAllocatePoolWithTag(pool_type, IrpSp->Parameters.Create.EaLength, ALLOC_TAG);
+                    if (!fileref->fcb->ea_xattr.Buffer) {
+                        ERR("out of memory\n");
+                        Status = STATUS_INSUFFICIENT_RESOURCES;
+
+                        IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                        free_fileref(Vcb, fileref);
+                        ExReleaseResourceLite(&Vcb->fcb_lock);
+
+                        goto exit;
+                    }
+
+                    fileref->fcb->ea_xattr.Length = fileref->fcb->ea_xattr.MaximumLength = (USHORT)IrpSp->Parameters.Create.EaLength;
+                    RtlCopyMemory(fileref->fcb->ea_xattr.Buffer, Irp->AssociatedIrp.SystemBuffer, fileref->fcb->ea_xattr.Length);
+                } else {
+                    if (fileref->fcb->ea_xattr.Length > 0) {
+                        ExFreePool(fileref->fcb->ea_xattr.Buffer);
+                        fileref->fcb->ea_xattr.Buffer = NULL;
+                        fileref->fcb->ea_xattr.Length = fileref->fcb->ea_xattr.MaximumLength = 0;
+
+                        fileref->fcb->ea_changed = TRUE;
+                        fileref->fcb->ealen = 0;
+                    }
                 }
-                
-                fileref->fcb->ealen = 4;
-                
-                // capitalize EA name
-                eainfo = Irp->AssociatedIrp.SystemBuffer;
-                do {
-                    STRING s;
-                    
-                    s.Length = s.MaximumLength = eainfo->EaNameLength;
-                    s.Buffer = eainfo->EaName;
-                    
-                    RtlUpperString(&s, &s);
-                    
-                    fileref->fcb->ealen += 5 + eainfo->EaNameLength + eainfo->EaValueLength;
-                    
-                    if (eainfo->NextEntryOffset == 0)
-                        break;
-                    
-                    eainfo = (FILE_FULL_EA_INFORMATION*)(((UINT8*)eainfo) + eainfo->NextEntryOffset);
-                } while (TRUE);
-                
-                if (fileref->fcb->ea_xattr.Buffer)
-                    ExFreePool(fileref->fcb->ea_xattr.Buffer);
-                
-                fileref->fcb->ea_xattr.Buffer = ExAllocatePoolWithTag(pool_type, Stack->Parameters.Create.EaLength, ALLOC_TAG);
-                if (!fileref->fcb->ea_xattr.Buffer) {
-                    ERR("out of memory\n");
-                    Status = STATUS_INSUFFICIENT_RESOURCES;
-                    
-                    free_fileref(fileref);
-                    goto exit;
-                }
-                
-                fileref->fcb->ea_xattr.Length = fileref->fcb->ea_xattr.MaximumLength = Stack->Parameters.Create.EaLength;
-                RtlCopyMemory(fileref->fcb->ea_xattr.Buffer, Irp->AssociatedIrp.SystemBuffer, Stack->Parameters.Create.EaLength);
-            } else {
-                if (fileref->fcb->ea_xattr.Length > 0) {
-                    ExFreePool(fileref->fcb->ea_xattr.Buffer);
-                    fileref->fcb->ea_xattr.Buffer = NULL;
-                    fileref->fcb->ea_xattr.Length = fileref->fcb->ea_xattr.MaximumLength = 0;
-                    
-                    fileref->fcb->ea_changed = TRUE;
-                    fileref->fcb->ealen = 0;
-                }
             }
-            
-            filter = FILE_NOTIFY_CHANGE_SIZE | FILE_NOTIFY_CHANGE_LAST_WRITE;
-            
-            mark_fcb_dirty(fileref->fcb);
-            
-            oldatts = fileref->fcb->atts;
-            
-            defda = get_file_attributes(Vcb, &fileref->fcb->inode_item, fileref->fcb->subvol, fileref->fcb->inode, fileref->fcb->type,
-                                        fileref->filepart.Length > 0 && fileref->filepart.Buffer[0] == '.', TRUE, Irp);
-            
-            if (RequestedDisposition == FILE_SUPERSEDE)
-                fileref->fcb->atts = Stack->Parameters.Create.FileAttributes | FILE_ATTRIBUTE_ARCHIVE;
-            else
-                fileref->fcb->atts |= Stack->Parameters.Create.FileAttributes | FILE_ATTRIBUTE_ARCHIVE;
-            
-            if (fileref->fcb->atts != oldatts) {
-                fileref->fcb->atts_changed = TRUE;
-                fileref->fcb->atts_deleted = Stack->Parameters.Create.FileAttributes == defda;
-                filter |= FILE_NOTIFY_CHANGE_ATTRIBUTES;
-            }
-            
+
             KeQuerySystemTime(&time);
             win_time_to_unix(time, &now);
-            
-            fileref->fcb->inode_item.transid = Vcb->superblock.generation;
-            fileref->fcb->inode_item.sequence++;
-            fileref->fcb->inode_item.st_ctime = now;
-            fileref->fcb->inode_item.st_mtime = now;
-            fileref->fcb->inode_item_changed = TRUE;
 
-            // FIXME - truncate streams
-            // FIXME - do we need to alter parent directory's times?
-            
-            send_notification_fcb(fileref, filter, FILE_ACTION_MODIFIED);
+            filter = FILE_NOTIFY_CHANGE_SIZE | FILE_NOTIFY_CHANGE_LAST_WRITE;
+
+            if (fileref->fcb->ads) {
+                fileref->parent->fcb->inode_item.st_mtime = now;
+                fileref->parent->fcb->inode_item_changed = TRUE;
+                mark_fcb_dirty(fileref->parent->fcb);
+
+                send_notification_fcb(fileref->parent, filter, FILE_ACTION_MODIFIED, &fileref->dc->name);
+            } else {
+                mark_fcb_dirty(fileref->fcb);
+
+                oldatts = fileref->fcb->atts;
+
+                defda = get_file_attributes(Vcb, fileref->fcb->subvol, fileref->fcb->inode, fileref->fcb->type,
+                                            fileref->dc && fileref->dc->name.Length >= sizeof(WCHAR) && fileref->dc->name.Buffer[0] == '.', TRUE, Irp);
+
+                if (RequestedDisposition == FILE_SUPERSEDE)
+                    fileref->fcb->atts = IrpSp->Parameters.Create.FileAttributes | FILE_ATTRIBUTE_ARCHIVE;
+                else
+                    fileref->fcb->atts |= IrpSp->Parameters.Create.FileAttributes | FILE_ATTRIBUTE_ARCHIVE;
+
+                if (fileref->fcb->atts != oldatts) {
+                    fileref->fcb->atts_changed = TRUE;
+                    fileref->fcb->atts_deleted = IrpSp->Parameters.Create.FileAttributes == defda;
+                    filter |= FILE_NOTIFY_CHANGE_ATTRIBUTES;
+                }
+
+                fileref->fcb->inode_item.transid = Vcb->superblock.generation;
+                fileref->fcb->inode_item.sequence++;
+                fileref->fcb->inode_item.st_ctime = now;
+                fileref->fcb->inode_item.st_mtime = now;
+                fileref->fcb->inode_item_changed = TRUE;
+
+                send_notification_fcb(fileref, filter, FILE_ACTION_MODIFIED, NULL);
+            }
         } else {
             if (options & FILE_NO_EA_KNOWLEDGE && fileref->fcb->ea_xattr.Length > 0) {
                 FILE_FULL_EA_INFORMATION* ffei = (FILE_FULL_EA_INFORMATION*)fileref->fcb->ea_xattr.Buffer;
-                
+
                 do {
                     if (ffei->Flags & FILE_NEED_EA) {
                         WARN("returning STATUS_ACCESS_DENIED as no EA knowledge\n");
-                        free_fileref(fileref);
                         Status = STATUS_ACCESS_DENIED;
+
+                        IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+                        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                        free_fileref(Vcb, fileref);
+                        ExReleaseResourceLite(&Vcb->fcb_lock);
+
                         goto exit;
                     }
-                    
+
                     if (ffei->NextEntryOffset == 0)
                         break;
-                    
+
                     ffei = (FILE_FULL_EA_INFORMATION*)(((UINT8*)ffei) + ffei->NextEntryOffset);
                 } while (TRUE);
             }
         }
-    
+
         FileObject->FsContext = fileref->fcb;
-        
+
         ccb = ExAllocatePoolWithTag(NonPagedPool, sizeof(*ccb), ALLOC_TAG);
         if (!ccb) {
             ERR("out of memory\n");
-            free_fileref(fileref);
             Status = STATUS_INSUFFICIENT_RESOURCES;
+
+            IoRemoveShareAccess(FileObject, &fileref->fcb->share_access);
+
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+
             goto exit;
         }
-        
+
         RtlZeroMemory(ccb, sizeof(*ccb));
-        
+
         ccb->NodeType = BTRFS_NODE_TYPE_CCB;
-        ccb->NodeSize = sizeof(ccb);
+        ccb->NodeSize = sizeof(*ccb);
         ccb->disposition = RequestedDisposition;
         ccb->options = options;
         ccb->query_dir_offset = 0;
@@ -3350,30 +3397,26 @@
         ccb->has_wildcard = FALSE;
         ccb->specific_file = FALSE;
         ccb->access = granted_access;
-        ccb->case_sensitive = Stack->Flags & SL_CASE_SENSITIVE;
-        
+        ccb->case_sensitive = IrpSp->Flags & SL_CASE_SENSITIVE;
+        ccb->reserving = FALSE;
+        ccb->lxss = called_from_lxss();
+
         ccb->fileref = fileref;
-        
+
         FileObject->FsContext2 = ccb;
-        
-        if (fn_offset > 0) {
-            fn.Length -= fn_offset * sizeof(WCHAR);
-            RtlMoveMemory(&fn.Buffer[0], &fn.Buffer[fn_offset], fn.Length);
-        }
-        
         FileObject->SectionObjectPointer = &fileref->fcb->nonpaged->segment_object;
-        
+
         if (NT_SUCCESS(Status)) {
             switch (RequestedDisposition) {
                 case FILE_SUPERSEDE:
                     Irp->IoStatus.Information = FILE_SUPERSEDED;
                     break;
-                    
+
                 case FILE_OPEN:
                 case FILE_OPEN_IF:
                     Irp->IoStatus.Information = FILE_OPENED;
                     break;
-                    
+
                 case FILE_OVERWRITE:
                 case FILE_OVERWRITE_IF:
                     Irp->IoStatus.Information = FILE_OVERWRITTEN;
@@ -3380,39 +3423,39 @@
                     break;
             }
         }
-        
+
         // Make sure paging files don't have any extents marked as being prealloc,
         // as this would mean we'd have to lock exclusively when writing.
-        if (Stack->Flags & SL_OPEN_PAGING_FILE) {
+        if (IrpSp->Flags & SL_OPEN_PAGING_FILE) {
             LIST_ENTRY* le;
             BOOL changed = FALSE;
-            
+
             ExAcquireResourceExclusiveLite(fileref->fcb->Header.Resource, TRUE);
-            
+
             le = fileref->fcb->extents.Flink;
-            
+
             while (le != &fileref->fcb->extents) {
                 extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-                
-                if (ext->data->type == EXTENT_TYPE_PREALLOC) {
-                    ext->data->type = EXTENT_TYPE_REGULAR;
+
+                if (ext->extent_data.type == EXTENT_TYPE_PREALLOC) {
+                    ext->extent_data.type = EXTENT_TYPE_REGULAR;
                     changed = TRUE;
                 }
-                
+
                 le = le->Flink;
             }
-            
+
             ExReleaseResourceLite(fileref->fcb->Header.Resource);
-            
+
             if (changed) {
                 fileref->fcb->extents_changed = TRUE;
                 mark_fcb_dirty(fileref->fcb);
             }
-            
+
             fileref->fcb->Header.Flags2 |= FSRTL_FLAG2_IS_PAGING_FILE;
             Vcb->disallow_dismount = TRUE;
         }
-        
+
 #ifdef DEBUG_FCB_REFCOUNTS
         oc = InterlockedIncrement(&fileref->open_count);
         ERR("fileref %p: open_count now %i\n", fileref, oc);
@@ -3425,30 +3468,47 @@
         open_type = 2;
 #endif
         Status = file_create(Irp, DeviceObject->DeviceExtension, FileObject, related, loaded_related, &fn, RequestedDisposition, options, rollback);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
+
         Irp->IoStatus.Information = NT_SUCCESS(Status) ? FILE_CREATED : 0;
     }
-    
+
     if (NT_SUCCESS(Status) && !(options & FILE_NO_INTERMEDIATE_BUFFERING))
         FileObject->Flags |= FO_CACHE_SUPPORTED;
-    
+
 exit:
-    ExReleaseResourceLite(&Vcb->fcb_lock);
-    
-exit2:
-    if (loaded_related)
-        free_fileref(related);
-    
-    if (NT_SUCCESS(Status)) {
+    if (loaded_related) {
+        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+        free_fileref(Vcb, related);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
+    }
+
+    if (Status == STATUS_SUCCESS) {
+        fcb* fcb2;
+
+        IrpSp->Parameters.Create.SecurityContext->AccessState->PreviouslyGrantedAccess |= granted_access;
+        IrpSp->Parameters.Create.SecurityContext->AccessState->RemainingDesiredAccess &= ~(granted_access | MAXIMUM_ALLOWED);
+
         if (!FileObject->Vpb)
             FileObject->Vpb = DeviceObject->Vpb;
-    } else {
-        if (Status != STATUS_OBJECT_NAME_NOT_FOUND && Status != STATUS_OBJECT_PATH_NOT_FOUND)
-            TRACE("returning %08x\n", Status);
-    }
-    
+
+        fcb2 = FileObject->FsContext;
+
+        if (fcb2->ads) {
+            struct _ccb* ccb2 = FileObject->FsContext2;
+
+            fcb2 = ccb2->fileref->parent->fcb;
+        }
+
+        ExAcquireResourceExclusiveLite(fcb2->Header.Resource, TRUE);
+        fcb_load_csums(Vcb, fcb2, Irp);
+        ExReleaseResourceLite(fcb2->Header.Resource);
+    } else if (Status != STATUS_REPARSE && Status != STATUS_OBJECT_NAME_NOT_FOUND && Status != STATUS_OBJECT_PATH_NOT_FOUND)
+        TRACE("returning %08x\n", Status);
+
 #ifdef DEBUG_STATS
     time2 = KeQueryPerformanceCounter(NULL);
-    
+
     if (open_type == 0) {
         Vcb->stats.open_total_time += time2.QuadPart - time1.QuadPart;
         Vcb->stats.num_opens++;
@@ -3460,68 +3520,69 @@
         Vcb->stats.num_creates++;
     }
 #endif
-    
+
     return Status;
 }
 
-NTSTATUS verify_vcb(device_extension* Vcb, PIRP Irp) {
+static NTSTATUS verify_vcb(device_extension* Vcb, PIRP Irp) {
     NTSTATUS Status;
     LIST_ENTRY* le;
-    
+    BOOL need_verify = FALSE;
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
-        
-        if (dev->removable) {
+
+        if (dev->devobj && dev->removable) {
             ULONG cc;
             IO_STATUS_BLOCK iosb;
-            
+
             Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
-            
-            if (!NT_SUCCESS(Status)) {
-                ERR("dev_ioctl returned %08x\n", Status);
+
+            if (IoIsErrorUserInduced(Status)) {
+                ERR("IOCTL_STORAGE_CHECK_VERIFY returned %08x (user-induced)\n", Status);
+                need_verify = TRUE;
+            } else if (!NT_SUCCESS(Status)) {
+                ERR("IOCTL_STORAGE_CHECK_VERIFY returned %08x\n", Status);
                 goto end;
-            }
-            
-            if (iosb.Information < sizeof(ULONG)) {
+            } else if (iosb.Information < sizeof(ULONG)) {
                 ERR("iosb.Information was too short\n");
                 Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            if (cc != dev->change_count) {
-                PDEVICE_OBJECT devobj;
-                
+            } else if (cc != dev->change_count) {
                 dev->devobj->Flags |= DO_VERIFY_VOLUME;
-                
-                devobj = IoGetDeviceToVerify(Irp->Tail.Overlay.Thread);
-                IoSetDeviceToVerify(Irp->Tail.Overlay.Thread, NULL);
-                
-                if (!devobj) {
-                    devobj = IoGetDeviceToVerify(PsGetCurrentThread());
-                    IoSetDeviceToVerify(PsGetCurrentThread(), NULL);
-                }
-                
-                devobj = Vcb->Vpb ? Vcb->Vpb->RealDevice : NULL;
-                
-                if (devobj)
-                    IoVerifyVolume(devobj, FALSE);
-                
-                Status = STATUS_VERIFY_REQUIRED;
-                goto end;
+                need_verify = TRUE;
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
+    if (need_verify) {
+        PDEVICE_OBJECT devobj;
+
+        devobj = IoGetDeviceToVerify(Irp->Tail.Overlay.Thread);
+        IoSetDeviceToVerify(Irp->Tail.Overlay.Thread, NULL);
+
+        if (!devobj) {
+            devobj = IoGetDeviceToVerify(PsGetCurrentThread());
+            IoSetDeviceToVerify(PsGetCurrentThread(), NULL);
+        }
+
+        devobj = Vcb->Vpb ? Vcb->Vpb->RealDevice : NULL;
+
+        if (devobj)
+            Status = IoVerifyVolume(devobj, FALSE);
+        else
+            Status = STATUS_VERIFY_REQUIRED;
+    }
+
     return Status;
 }
 
@@ -3536,92 +3597,118 @@
     return SePrivilegeCheck(&privset, &access_state->SubjectSecurityContext, processor_mode) ? TRUE : FALSE;
 }
 
-NTSTATUS STDCALL drv_create(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_CREATE)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_create(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
     NTSTATUS Status;
     PIO_STACK_LOCATION IrpSp;
     device_extension* Vcb = DeviceObject->DeviceExtension;
     BOOL top_level, locked = FALSE;
-    LIST_ENTRY rollback;
-    
+
+    FsRtlEnterFileSystem();
+
     TRACE("create (flags = %x)\n", Irp->Flags);
-    
-    InitializeListHead(&rollback);
-    
-    FsRtlEnterFileSystem();
-    
+
     top_level = is_top_level(Irp);
-    
+
     /* return success if just called for FS device object */
-    if (DeviceObject == devobj || (Vcb && Vcb->type == VCB_TYPE_PARTITION0))  {
+    if (DeviceObject == master_devobj)  {
         TRACE("create called for FS device object\n");
-        
+
         Irp->IoStatus.Information = FILE_OPENED;
         Status = STATUS_SUCCESS;
 
         goto exit;
+    } else if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_create(DeviceObject, Irp);
+        goto exit;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto exit;
     }
-    
+
+    if (!(Vcb->Vpb->Flags & VPB_MOUNTED)) {
+        Status = STATUS_DEVICE_NOT_READY;
+        goto exit;
+    }
+
+    if (Vcb->removing) {
+        Status = STATUS_ACCESS_DENIED;
+        goto exit;
+    }
+
     Status = verify_vcb(Vcb, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("verify_vcb returned %08x\n", Status);
         goto exit;
     }
-    
+
     ExAcquireResourceSharedLite(&Vcb->load_lock, TRUE);
     locked = TRUE;
-    
+
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
-    
+
     if (IrpSp->Flags != 0) {
         UINT32 flags = IrpSp->Flags;
-        
+
         TRACE("flags:\n");
-        
+
         if (flags & SL_CASE_SENSITIVE) {
             TRACE("SL_CASE_SENSITIVE\n");
             flags &= ~SL_CASE_SENSITIVE;
         }
-        
+
         if (flags & SL_FORCE_ACCESS_CHECK) {
             TRACE("SL_FORCE_ACCESS_CHECK\n");
             flags &= ~SL_FORCE_ACCESS_CHECK;
         }
-        
+
         if (flags & SL_OPEN_PAGING_FILE) {
             TRACE("SL_OPEN_PAGING_FILE\n");
             flags &= ~SL_OPEN_PAGING_FILE;
         }
-        
+
         if (flags & SL_OPEN_TARGET_DIRECTORY) {
             TRACE("SL_OPEN_TARGET_DIRECTORY\n");
             flags &= ~SL_OPEN_TARGET_DIRECTORY;
         }
-        
+
         if (flags & SL_STOP_ON_SYMLINK) {
             TRACE("SL_STOP_ON_SYMLINK\n");
             flags &= ~SL_STOP_ON_SYMLINK;
         }
-        
+
         if (flags)
             WARN("unknown flags: %x\n", flags);
     } else {
         TRACE("flags: (none)\n");
     }
-    
-//     Vpb = DeviceObject->DeviceExtension;
-    
-//     TRACE("create called for something other than FS device object\n");
-    
+
+    if (!IrpSp->FileObject) {
+        ERR("FileObject was NULL\n");
+        Status = STATUS_INVALID_PARAMETER;
+        goto exit;
+    }
+
+    if (IrpSp->FileObject->RelatedFileObject) {
+        fcb* relatedfcb = IrpSp->FileObject->RelatedFileObject->FsContext;
+
+        if (relatedfcb && relatedfcb->Vcb != Vcb) {
+            WARN("RelatedFileObject was for different device\n");
+            Status = STATUS_INVALID_PARAMETER;
+            goto exit;
+        }
+    }
+
     // opening volume
-    // FIXME - also check if RelatedFileObject is Vcb
     if (IrpSp->FileObject->FileName.Length == 0 && !IrpSp->FileObject->RelatedFileObject) {
         ULONG RequestedDisposition = ((IrpSp->Parameters.Create.Options >> 24) & 0xff);
         ULONG RequestedOptions = IrpSp->Parameters.Create.Options & FILE_VALID_OPTION_FLAGS;
 #ifdef DEBUG_FCB_REFCOUNTS
-        LONG rc, oc;
+        LONG rc;
 #endif
         ccb* ccb;
-        
+
         TRACE("open operation for volume\n");
 
         if (RequestedDisposition != FILE_OPEN && RequestedDisposition != FILE_OPEN_IF) {
